package app;

import menu.HomeMenu;
import menu.RootMenu;
import data.LocalDataBase;
import tool.MyStack;
import user.Administer;
import user.Developer;
import user.GeneralUser;
import user.User;

public class ConcertSystem extends RootMenu{
    private static ConcertSystem concertSystem;
    public static LocalDataBase localDataBase;
    public static MyStack<RootMenu> menuStack;
    private static User currentUser = null;

    private ConcertSystem() {
        localDataBase = LocalDataBase.getLocalDataBase();
        menuStack = new MyStack<>();
        actionList = "> 1.进入系统 2.退出";
        actionCount = 2;
    }

    /**
     * 提供外部可访问单例对象的方法
     */
    public static ConcertSystem getConcertSystem() {
        if (concertSystem == null) {
            concertSystem = new ConcertSystem();
            menuStack.push(concertSystem);
        }
        return concertSystem;
    }

    public static User getCurrentUser() {
        return currentUser;
    }
    public static void setCurrentUser(User user) {
        currentUser = user;
        if (currentUser instanceof Developer) {
            currentUser.setActionList("> 1.案例测试 2.查看所有用户 3.查看个人信息 4.修改密码" +
                    " 5.更新个人信息 6.刷新文件数据库 7.清除用户 8.登出");
            currentUser.setActionCount(8);
        } else if (currentUser instanceof Administer) {
            currentUser.setActionList("> 1.案例测试 2.查看所有用户 3.查看个人信息 4.修改密码 5.更新个人信息 6.登出");
            currentUser.setActionCount(6);
        } else if (currentUser instanceof GeneralUser) {
            currentUser.setActionList("> 1.案例测试 2.查看个人信息 3.修改密码 4.更新个人信息 5.登出");
            currentUser.setActionCount(5);
        }
    }
    public boolean run() {
        System.out.println("> ------------------------------------");
        System.out.println("> \t\t正在启动Java案例演示系统");
        System.out.println("> ------------------------------------");
        System.out.println("> \t\t正在加载数据...");
        localDataBase.loadDataBase();//加载完毕
        int success;
        while ((success = this.action()) != 0) {//那就是还不想退出
//            if (success > 0) { //正常登录进去
////                while (currentUser.wakeMenu() != 0) {
////
////                }
//            }
        }
        //this.action()是false说明要退出系统 那么就不操作
        return false;
    }

    @Override
    public int action() {//定义主系统的行为
        System.out.println(actionList);
        int tag = scanner.nextInt(1,actionCount);
        int success = 0;
        switch (tag) {
            case 1:
                while ((success = HomeMenu.getHomeMenu().action()) != 0) {
                    if( success > 0) {
                        while (currentUser.wakeMenu() != 0) {

                        }
                    }

                }

                break;
            case 2:
                System.out.println("> 正在退出系统...");
                break;
        }
        return tag == 2 ? 0 : tag;
    }
}
