package menu;

import app.ConcertSystem;

/**
 * 登录界面
 * 行为：注册 登录
 * 表单：账号 密码
 */
public class HomeMenu extends RootMenu {
    private static HomeMenu homeMenu;
    private HomeMenu() {
        actionList = "> 请选择：1.注册 2.登录 3.返回";
        actionCount = 3;
    }
    public static HomeMenu getHomeMenu() {
        if (homeMenu == null) {
            homeMenu = new HomeMenu();
        }
        return homeMenu;
    }
    @Override
    public int action() {
        ConcertSystem.menuStack.push(homeMenu);
        int success = 0;
        System.out.println(actionList);
        int tag = scanner.nextInt(1, 3);
        switch (tag) {
            case 1:
                success = registerButton();
                break;
            case 2:
                success = loginButton();
                break;
            case 3:
                success = 0;
                break;
        }
        ConcertSystem.menuStack.pop();
        return success;
    }
    public int registerButton() {
        int success = -1;
        RootMenu registerMenu = new RegisterMenu();
        ConcertSystem.menuStack.push(registerMenu);//register 入栈
        success = registerMenu.action();//register 出栈

        return success;
    }
    public int loginButton() {
        RootMenu loginMenu = new LoginMenu();
        ConcertSystem.menuStack.push(loginMenu);
        return loginMenu.action();
    }


}