package menu.demo;

import app.ConcertSystem;
import menu.RootMenu;

import java.lang.reflect.Method;
import java.util.Arrays;

public class ArrayMenu extends RootMenu {
    @Override
    public int action() {
        ConcertSystem.menuStack.push(this);
        String[] strings = {"数组操作",
                "返回"};
        String[] methods = {"arrayOperation"};

        for (int i = 1; i <= strings.length; i++) {
            System.out.println("> " + i + "." + strings[i-1]);
        }
        int methodCount = strings.length;// 包括了 返回 这个操作，如果是选择返回 下面因为没有对应的方法会异常，也就退出了
        int tag = scanner.nextInt(1,methodCount);
        try {
            ArrayMenu my = new ArrayMenu();
            Method currentMethod = ArrayMenu.class.getMethod(methods[tag-1]);
            currentMethod.invoke(my);
        } catch (Exception e) {
//            System.out.println("> 没有这个方法案例或其它异常!!!!!");
        }
        ConcertSystem.menuStack.pop();
        return tag == methodCount ? 0 : tag;
    }
    public void arrayOperation() {
        System.out.println("-----------------------------------------");
        System.out.println("> 场景：数组的一些常用操作方法");
        System.out.println("> 请连续输入一串整数，以空格分隔\t\tScanner.nextLine().split(\" \") \tInteger.parseInt()");
        String[] numStr = scanner.nextLine().split(" ");
        int[] numbers = new int[numStr.length];
        for(int i = 0; i< numStr.length; i++){
            numbers[i] = Integer.parseInt(numStr[i]);
        }

        // 访问数组元素
        System.out.println("> 第一个元素：" + numbers[0] + "\t\t[]索引");
        System.out.println("> 数组长度：" + numbers.length + "\t\tlength属性");

        // 遍历数组
        System.out.println("> 数组元素：\t\tfor遍历");
        for (int i = 0; i < numbers.length; i++) {
            System.out.println(numbers[i]);
        }

        // 修改第一个数组元素
        System.out.println("> 修改第一个数组元素为100\t\t[]索引修改");
        numbers[0] = 100;
        System.out.println("> 数组元素：");
        for (int i = 0; i < numbers.length; i++) {
            System.out.println(numbers[i]);
        }

        // 查找数组元素
        int index = findElement(numbers, numbers[2]);
        System.out.println("> 元素 " + numbers[2] + " 的索引：" + index + "\t\t自定义find");

        // 数组排序
        sortArray(numbers);

        // 数组拷贝
        int[] copiedArray = copyArray(numbers);
        System.out.println("> 拷贝后的数组: \t\tcopyOf()");
        for (int i = 0; i < copiedArray.length; i++) {
            System.out.println(copiedArray[i]);
        }
        System.out.println("> 原数组的hashcode: \t\thashCode()" + numbers.hashCode());
        System.out.println("> 拷贝数组的hashcode: \t\thashCode()" + copiedArray.hashCode() + " 地址不同 已拷贝" + "\n");
    }
    public static int findElement(int[] arr, int target) {
        for (int i = 0; i < arr.length; i++) {
            if (arr[i] == target) {
                return i;
            }
        }
        return -1;
    }

    // 数组排序
    public static void sortArray(int[] arr) {
        Arrays.sort(arr);
        System.out.println("> 排序后的数组: \t\tsort()");
        for (int i = 0; i < arr.length; i++) {
            System.out.println(arr[i]);
        }
    }

    // 数组拷贝
    public static int[] copyArray(int[] arr) {
        int[] copiedArray = Arrays.copyOf(arr, arr.length);
        return copiedArray;
    }
}
