package menu.demo;

import app.ConcertSystem;
import menu.RootMenu;

import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

public class CollectionMenu extends RootMenu {
    @Override
    public int action() {
        ConcertSystem.menuStack.push(this);
        String[] strings = {"工厂产量",
                "返回"};
        String[] methods = {"materialManagement"};

        for (int i = 1; i <= strings.length; i++) {
            System.out.println("> " + i + "." + strings[i-1]);
        }
        int methodCount = strings.length;// 包括了 返回 这个操作，如果是选择返回 下面因为没有对应的方法会异常，也就退出了
        int tag = scanner.nextInt(1,methodCount);
        try {
            CollectionMenu my = new CollectionMenu();
            Method currentMethod = CollectionMenu.class.getMethod(methods[tag-1]);
            currentMethod.invoke(my);
        } catch (Exception e) {
//            System.out.println("> 没有这个方法案例或其它异常!!!!!");
        }
        ConcertSystem.menuStack.pop();
        return tag == methodCount ? 0 : tag;
    }

    public void materialManagement() {
        System.out.println("-----------------------------------------");
        System.out.println("> 场景：查询修改工厂的产量信息");
        HashMap<String, Integer> factoryYield = new HashMap<>();

        // 添加产量信息
        factoryYield.put("二厂", 140);
        factoryYield.put("四厂", 120);
        factoryYield.put("五厂", 180);
        factoryYield.put("七厂", 200);

        // 获取所有工厂名称
        System.out.println("> 所有工厂信息: \t\tkeySet()获取名称");
        for (String name : factoryYield.keySet()) {
            System.out.println("> 名称: " + name + "\t产量: " + factoryYield.get(name));
        }

        // 获取指定工厂的产量
        String factoryName = "五厂";
        if (factoryYield.containsKey(factoryName)) {
            int score = factoryYield.get(factoryName);
            System.out.println("> 经查询 " + factoryName + " 的产量为: " + score + "\t\tcontainsKey()判断字段");
        } else {
            System.out.println("> " + factoryName + " 不存在！");
        }
        System.out.println();

        // 修改工厂的产量
        factoryName = "二厂";
        int count = 200;
        if (factoryYield.containsKey(factoryName)) {
            factoryYield.put(factoryName, count);
            System.out.println("> 已修改 " + factoryName + " 的产量为: " + count + "\t\tput()覆盖");
        } else {
            System.out.println("> " + factoryName + " 不存在！");
        }
        System.out.println();

        // 删除工厂信息
        factoryName = "四厂";
        if (factoryYield.containsKey(factoryName)) {
            int removedScore = factoryYield.remove(factoryName);
            System.out.println("> " + factoryName + " 的信息已删除，其原产量为: " + removedScore + "\t\tremove()移除元素");
        } else {
            System.out.println("> " + factoryName + " 不存在！");
        }
        System.out.println();

        // 遍历所有工厂信息
        System.out.println("> 当前所有工厂的信息: \t\tEntry接口");
        for (HashMap.Entry<String, Integer> entry : factoryYield.entrySet()) {
            String name = entry.getKey();
            int score = entry.getValue();
            System.out.println("> " + name + " 的产量为: " + score);
        }
        System.out.println();

        // 检查工厂数量
        int facCount = factoryYield.size();
        System.out.println("> 工厂总数量为: " + facCount + "\t\tsize()获取大小");
        System.out.println();

        // 检查是否有超过指定产量的厂
        int scoreToCheck = 190;
        System.out.print("> 产量超过 190 的工厂有: ");
        for(Map.Entry<String, Integer> entry : factoryYield.entrySet()) {
            if(entry.getValue() > 190){
                System.out.print(entry.getKey() + "\t");
            }
        }
        System.out.print("\n");
    }
}
