package menu.demo;

import app.ConcertSystem;
import menu.RootMenu;

import java.lang.reflect.Method;

public class ControlMenu extends RootMenu {
    @Override
    public int action() {
        ConcertSystem.menuStack.push(this);
        String[] strings = {"顺序结构: 数据运算符操作",
                "分支结构: 条件判断执行",
                "循环结构: 循环打印",
                "返回"};
        String[] methods = {"sequence","branchStructure","loopStructure"};
        for (int i = 1; i <= strings.length; i++) {
            System.out.println("> " + i + "." + strings[i-1]);
        }
        int methodCount = strings.length;
        int tag = scanner.nextInt(1,methodCount);
        try {
            ControlMenu my = new ControlMenu();
            Method currentMethod = ControlMenu.class.getMethod(methods[tag-1]);
            currentMethod.invoke(my);
        } catch (Exception e) {
//            System.out.println("> 没有这个方法案例或其它异常!!!!!");
        }
        ConcertSystem.menuStack.pop();
        return tag == methodCount ? 0 : tag;
    }

    public void sequence() {
        System.out.println("> ----------------------------------------------");
        System.out.println("> 场景描述：依次输入两个整数，操作两个数，输出最终结果");
        System.out.println("> ----------------整型测试-----------------------");
        System.out.println("> 第一个数 x: ");
        int x = scanner.nextInt(Integer.MIN_VALUE, Integer.MAX_VALUE);
        System.out.println("> 第二个数 y: ");
        int y = scanner.nextInt(Integer.MIN_VALUE, Integer.MAX_VALUE);
        System.out.println("> x + y = "+ (x + y));
        System.out.println("> x - y = "+ (x - y));
        System.out.println("> x * y = "+ (x * y));
        System.out.println("> x / y = "+ (x / y));
        System.out.println("> ----------------浮点测试-----------------------");
        System.out.println("> 第一个数 m: ");
        double m = scanner.nextDouble();
        System.out.println("> 第二个数 n: ");
        double n = scanner.nextDouble();
        System.out.println("> (m / n) = "+ (m / n));
        System.out.println("> (int)(m / n) = "+ (int)(m / n));
        System.out.println("> ceil(m / n) = "+ Math.ceil(m / n));
        System.out.println("> floor(m / n) = "+ Math.floor(m / n));
    }

    public void branchStructure() {
        System.out.println("> ----------------------------------------------");
        System.out.println("> 场景描述：输入一个数，判断正负等条件");
        System.out.println("> 请任意正负输入一个整数（推荐数值大一点）:");
        int num = scanner.nextInt(Integer.MIN_VALUE,Integer.MAX_VALUE);
        System.out.println("> ------------if-else分支展示结果-----------------");
        if (num > 0) {
            System.out.println("> 这是一个正数！");
        } else if (num < 0) {
            System.out.println("> 这是一个负数！");
        } else {
            System.out.println("> 输入的是0！");
        }

        System.out.println("> ------------switch-case分支展示结果-------------");
        switch (num) {
            case 1:
                System.out.println("> 这是一个正数！");
                break;
            case -1:
                System.out.println("> 这是一个负数！");
                break;
            case 0:
                System.out.println("> 输入的是0！");
                break;
            default:
                System.out.println("> 无法识别的数字！");
        }
        System.out.println("\n> 当条件分为几个大类或层次，但又不具体时，用if。");
        System.out.println("> 当条件确定，需要一一匹配时，可以用switch。一定不要忘记break！！！！\n");
    }

    public void loopStructure() {
        System.out.println("> ----------------------------------------------");
        System.out.println("> 场景描述：输出来自三辆小车的物料id号，每辆车3个");
        System.out.println("> ------------------for循环演示------------------");
        for(int i = 1; i <= 3; i++){
            for(int j = 1; j <= 3; j++) {
                System.out.println("接收到来自第 " + i + " 辆小车的第 " + (j + (i - 1)*3) + " 片电池片");
            }
        }
        System.out.println("> ------------------while循环演示----------------");
        int i = 0;
        while(++i <= 3) {
            int j = 0;
            while(++j <= 3){
                System.out.println("接收到来自第 " + i + " 辆小车的第 " + (j + (i - 1)*3) + " 片电池片");
            }
        }
        System.out.println("> ----------------do-while循环演示---------------");
        i = 1;
        do {
            int j = 1;
            do {
                System.out.println("接收到来自第 " + i + " 辆小车的第 " + (j + (i - 1)*3) + " 片电池片");
            } while (j++ < 3);
        } while(i++ < 3);
        System.out.println("\n> 不同的循环结构都能实现同样的功能！\n");
    }
}
