package menu.demo;

import app.ConcertSystem;
import menu.RootMenu;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.Method;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;

public class FileMenu extends RootMenu {
    @Override
    public int action() {
        ConcertSystem.menuStack.push(this);
        String[] strings = {"文件操作",
                "返回"};
        String[] methods = {"fileOperator"};

        for (int i = 1; i <= strings.length; i++) {
            System.out.println("> " + i + "." + strings[i-1]);
        }
        int methodCount = strings.length;// 包括了 返回 这个操作，如果是选择返回 下面因为没有对应的方法会异常，也就退出了
        int tag = scanner.nextInt(1,methodCount);
        try {
            FileMenu my = new FileMenu();
            Method currentMethod = FileMenu.class.getMethod(methods[tag-1]);
            currentMethod.invoke(my);
        } catch (Exception e) {
//            System.out.println("> 没有这个方法案例或其它异常!!!!!");
        }
        ConcertSystem.menuStack.pop();
        return tag == methodCount ? 0 : tag;
    }
    public void fileOperator() {
        System.out.println("> ------------------------------------------------");
        System.out.println("> -------------------文件操作-----------------------");
        File file = null;
        try {
            file = new File("./fileTest.txt");
            if (!file.exists()) {
                file.createNewFile();
                System.out.println("> 文件不存在，已通过 creatNewFile() 创建");
            } else {
                System.out.println("> exists() 检查到文件存在");
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

        System.out.println("> 文件绝对路径为: " + file.getAbsolutePath() + "\t\tgetAbsolutePath()");
        System.out.println("> 文件构造路径为: " + file.getPath() + "\t\tgetPath()");
        System.out.println("> 文件长度为: " + file.length() + " 字节\t\tlength()");
        System.out.println("> 文件最后修改时间: " + LocalDateTime.ofInstant(Instant.ofEpochMilli(file.lastModified()),
                ZoneId.of("Asia/Shanghai")) + "\t\tLocalDataTime.ofInstant()");
        System.out.println("> 文件权限: 可读:" + file.canRead() + " 可写:" + file.canWrite() + "\t\tcanRead() canWrite()");
        System.out.println("> 文件删除是否成功: " + file.delete() + "\t\tdelete()");
        System.out.println("> 文件是否还存在: " + file.exists() + "\t\texists()\n");
    }
}
