package menu.demo;

import app.ConcertSystem;
import menu.RootMenu;

import java.io.*;
import java.lang.reflect.Method;
import java.net.ServerSocket;
import java.net.Socket;

public class SocketMenu extends RootMenu {
    @Override
    public int action() {
        ConcertSystem.menuStack.push(this);
        String[] strings = {"socket测试",
                "返回"};
        String[] methods = {"runServerClient"};

        for (int i = 1; i <= strings.length; i++) {
            System.out.println("> " + i + "." + strings[i-1]);
        }
        int methodCount = strings.length;// 包括了 返回 这个操作，如果是选择返回 下面因为没有对应的方法会异常，也就退出了
        int tag = scanner.nextInt(1,methodCount);
        try {
            SocketMenu my = new SocketMenu();
            Method currentMethod = SocketMenu.class.getMethod(methods[tag-1]);
            currentMethod.invoke(my);
        } catch (Exception e) {
//            System.out.println("> 没有这个方法案例或其它异常!!!!!");
        }
        ConcertSystem.menuStack.pop();
        return tag == methodCount ? 0 : tag;
    }
    public void runServerClient() {
        // 启动服务器线程
        Thread serverThread = new Thread(() -> {
            try {
                // 创建 ServerSocket 对象并指定端口号
                ServerSocket serverSocket = new ServerSocket(9999);

                System.out.println("> 服务器已启动，等待客户端连接...\t\tServerSocket()");

                // 监听客户端连接
                Socket clientSocket = serverSocket.accept();
                System.out.println("> 客户端已连接！\t\tServerSocket().accept()");

                // 创建输入流和输出流
                InputStream inputStream = clientSocket.getInputStream();
                OutputStream outputStream = clientSocket.getOutputStream();

                // 读取客户端发送的数据
                BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
                String clientData = reader.readLine();
                System.out.println("> 客户端发送的数据：" + clientData);

                // 向客户端发送响应数据
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(outputStream));
                writer.write("> Hello from server!");
                writer.newLine();
                writer.flush();

                // 关闭连接
                inputStream.close();
                outputStream.close();
                clientSocket.close();
                serverSocket.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        });

        // 启动客户端线程
        Thread clientThread = new Thread(() -> {
            try {
                // 创建 Socket 对象，指定服务器主机名和端口号
                Socket socket = new Socket("localhost", 9999);
                System.out.println("> 客户端连接localhost:9999！\t\tSocket");

                // 创建输入流和输出流
                InputStream inputStream = socket.getInputStream();
                OutputStream outputStream = socket.getOutputStream();

                // 向服务器发送数据
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(outputStream));
                writer.write("> Hello from client!");
                writer.newLine();
                writer.flush();
                System.out.println("> 数据已发送到服务器！");

                // 读取服务器响应的数据
                BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
                String serverData = reader.readLine();
                System.out.println("> 服务器响应的数据：" + serverData);

                // 关闭连接
                inputStream.close();
                outputStream.close();
                socket.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        });

        // 启动服务器和客户端线程
        serverThread.start();
        clientThread.start();
    }
}
