package menu.demo;

import app.ConcertSystem;
import menu.RootMenu;
import tool.MyThread;

import java.lang.reflect.Method;
import java.util.concurrent.locks.ReentrantLock;

public class ThreadMenu extends RootMenu{

    private static Method currentMethod;

    @Override
    public int action() {
        ConcertSystem.menuStack.push(this);
        String[] strings = {"物料进货（无锁保护）","物料进货（lock保护）","物料进货（wait保护）",
                "返回"};
        String[] methods = {"addCellNone", "addCellLock", "addCellWait"};

        for (int i = 1; i <= strings.length; i++) {
            System.out.println("> " + i + "." + strings[i-1]);
        }
        int methodCount = strings.length;// 包括了 返回 这个操作，如果是选择返回 下面因为没有对应的方法会异常，也就退出了
        int tag = scanner.nextInt(1,methodCount);
        try {
            MyThread mythread = new MyThread();
            currentMethod = MyThread.class.getMethod(methods[tag-1],int.class);
            MyThread.setCell(0);
            Thread thread1 = new Thread(mythread, "进货员1");
            Thread thread2 = new Thread(mythread, "进货员2");
            long startTime = System.currentTimeMillis();
            thread1.start();
            thread2.start();
            thread1.join();
            thread2.join();
            long endTime = System.currentTimeMillis();
            System.out.println("> 耗时: " + (endTime - startTime) + " ms\n");
        } catch (Exception e) {
//            System.out.println("> 没有这个方法案例或其它异常!!!!!");
        }
        ConcertSystem.menuStack.pop();
        return tag == methodCount ? 0 : tag;
    }

    public static Method getCurrentMethod() {
        return currentMethod;
    }

    public static void setCurrentMethod(Method currentMethod) {
        ThreadMenu.currentMethod = currentMethod;
    }
}
