package tool;

import java.io.IOException;
import java.io.Serializable;
import java.util.InputMismatchException;
import java.util.Scanner;

public class MyScanner {
    private Scanner scanner;

    public MyScanner() {
        scanner = new Scanner(System.in);
    }

    public int nextInt(int min, int max) {
        int tag = -9999;
        boolean success = false;
        while (!success) {
            try {
                tag = scanner.nextInt();
                if (tag < min || tag > max) {
                    System.out.println("> Exception: 指令无法解析，请重新输入！");
                    continue;
                }
                success = true;
            } catch (InputMismatchException e) {
                System.out.println("> Exception: 类型不匹配，请重新输入！");
                scanner.nextLine();
            }
        }
        return tag;
    }
    public int nextInt(int min, int max, String str) {
        int tag = -9999;
        boolean success = false;
        while (!success) {
            try {
                tag = scanner.nextInt();
                if (tag < min || tag > max) {
                    System.out.println("> Exception: 指令无法解析，请重新输入！");
                    continue;
                }
                success = true;
            } catch (InputMismatchException e) {
                System.out.println("> Exception: 类型不匹配，请重新输入！");
                System.out.println(str);
                scanner.nextLine();
            }
        }
        return tag;
    }

    public String next() {
        return scanner.next();
    }
    public double nextDouble() {
        return scanner.nextDouble();
    }
    public String nextLine() {
        return scanner.nextLine();
    }
}
