package tool;

import menu.demo.ThreadMenu;

import java.util.concurrent.locks.ReentrantLock;

public class MyThread implements Runnable{
    private static int cell = 0;
    private static final ReentrantLock lock = new ReentrantLock();
    public static void addCellLock(int cell){
        try {
            lock.lock();
            MyThread.cell += cell;
            System.out.println(Thread.currentThread().getName() + " 添加Cell，当前数量: " + MyThread.cell);
        } finally {
            lock.unlock();
        }
        try{
            Thread.sleep(10);
        }catch (InterruptedException e){
            e.printStackTrace();
        }
    }
    public static void addCellNone(int cell){
        MyThread.cell += cell;
        System.out.println(Thread.currentThread().getName() + " 添加Cell，当前数量: " + MyThread.cell + " 目标总数: 60");
        try{
            Thread.sleep(10);
        }catch (InterruptedException e){
            e.printStackTrace();
        }
    }
    public static void addCellWait(int cell){
        synchronized(lock) {
            try {
                lock.notifyAll();
                MyThread.cell += cell;
                System.out.println(Thread.currentThread().getName() + " 添加Cell，当前数量: " + MyThread.cell + " 目标总数: 60");
                if (MyThread.cell != 60) {
                    lock.wait();
                }
            } catch (Exception e) {
                e.printStackTrace();
            } finally {

            }
        }

        try{
            Thread.sleep(10);
        }catch (InterruptedException e){
            e.printStackTrace();
        }
    }

    @Override
    public void run() {
        for(int i = 0; i< 30; i++){
            try{
                ThreadMenu.getCurrentMethod().invoke(null,1);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
    public static int getCell() {
        return cell;
    }

    public static void setCell(int cell) {
        MyThread.cell = cell;
    }
}
