package user;

import menu.DeveloperMenu;
import app.ConcertSystem;

/**
 * 开发者决定了服务器的开关，包括了所有的数据信息
 * 这里用读写本地文件替代
 */
public class Developer extends User implements IPerson {
    public Developer(String id, String password) {
        super(id,password);
        setRole(Role.DEVELOPER.toString());
        setName("randDev");
    }
    public Developer(String id, String password, boolean sex, int age){
        super(id, "name" ,password, sex, age, Role.DEVELOPER.toString());
    }

    @Override
    public int wakeMenu() {
        DeveloperMenu developerMenu = new DeveloperMenu();
        ConcertSystem.menuStack.push(developerMenu);
        return developerMenu.action();
    }

    public void viewUserMap() {
        ConcertSystem.localDataBase.printMap(ConcertSystem.localDataBase.getUserMap().values());
    }

    public void refreshUserMap() {
        ConcertSystem.localDataBase.refreshDataBase();
    }
    public void clearUser() {
        //不是自己就删掉
        ConcertSystem.localDataBase.getUserMap().entrySet().removeIf(entry -> !entry.getKey().equals(getId()));
    }
}
