package user;

import app.ConcertSystem;
import tool.MyScanner;
import tool.MyStack;

import java.io.Serializable;

public abstract class User implements Serializable {
    private String id;
    private String password;
    private String name;
    private boolean sex;
    private int age;
    private String role;
    private static int actionCount;
    private static String actionList;
    public User() {

    }

    public User(String id, String password) {
        this.id = id;
        this.password = password;
    }
    public User(String id, String name, String password, boolean sex, int age, String role) {
        this.id = id;
        this.name = name;
        this.password = password;
        this.sex = sex;
        this.age = age;
        this.role = role;
    }

    @Override
    public String toString() {
        return ("> id:" + String.format("%-15s",getId()) +"\tname:" + String.format("%-15s",getName())
                +"\tSex:" + String.format("%-15s", getSex()) +"\tAge:"
                + String.format("%-15d", getAge()) +"\tRole:" + String.format("%-15s",getRole()));
    }
    /**
     * 用于注册之后的正常个人信息初始化维护
     * @param name
     * @param sex
     * @param age
     * @return
     */
    public boolean updataInitialInfo(String name, boolean sex, int age) {
        setName(name);
        setSex(sex);
        setAge(age);
        return true;
    }
    public boolean updataInitialInfo() {
        MyScanner scanner = new MyScanner();
        System.out.println("> 请输入name:");
        setName(scanner.next());
        System.out.println("> 请输入sex(1.男 2.女):");
        int tse = scanner.nextInt(1,2);
        if (tse == 1) {
            setSex(true);
        } else {
            setSex(false);
        }
        System.out.println("> 请输入age:");
        setAge(scanner.nextInt(1,100));
        ConcertSystem.localDataBase.putUser(this);

        return true;
    }
    public boolean modifyPassword() {
        // 校验过程
        System.out.println("请输入新密码:");
        password = (new MyScanner()).next();
        setPassword(password);
        ConcertSystem.localDataBase.putUser(this);

        return true;
    }
    public abstract int wakeMenu();

    public String getId() {
        return id;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public boolean getSex() {
        return sex;
    }

    public void setSex(boolean sex) {
        this.sex = sex;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    public String getRole() {
        return role;
    }

    public void setRole(String role) {
        this.role = role;
    }

    public int getActionCount() {
        return actionCount;
    }

    public String getActionList() {
        return actionList;
    }

    public void setActionList(String actionList) {
        User.actionList = actionList;
    }

    public void setActionCount(int actionCount) {
        User.actionCount = actionCount;
    }
}
